<?php
require_once 'C:/......../config.core.php'; //указать ваш абсолютный путь до файла config.core.php
require_once MODX_CORE_PATH . 'model/modx/modx.class.php';
require_once MODX_CORE_PATH . '../assets/components/payment/config.php';

if ($_SERVER["REQUEST_METHOD"] == "POST") {
    $request = json_decode(file_get_contents("php://input"));
    $data = (array) $request;

    if ($data["TerminalKey"] == TERMINAL_KEY) {
        $modx = new modX();
        $modx->initialize('web');
        $modx->addPackage('shopkeeper3', $modx->getOption('core_path') . 'components/shopkeeper3/model/');
        $order_id = $data['OrderId'];
        $order = $modx->getObject('shk_order', $order_id);

        if ((isset($order)) && ($order > 0)) {
            $data['Password'] = PAY_PASSWORD;
            ksort($data);
            $original_token = $data['Token'];
            unset($data['Token']);
            $data['Success'] = $data['Success'] ? 'true' : 'false';
            $values = implode('', array_values($data));
            $token = hash('sha256', $values);

            $amount = round($order->get('price') * 100);

            if ((int)round($amount) !== (int)$data['Amount']) {
                die('AMOUNTS DO NOT MATCH');
            }

            switch ($request->Status) {
                case 'AUTHORIZED':
                    $order_status = 6;
                    break; //Деньги на карте захолдированы.
                case 'CONFIRMED':
                    $order_status = 6;
                    break; //Платеж подтвержден.
                case 'CANCELED':
                    $order_status = 5;
                    break; //Платеж отменен
                case 'REJECTED':
                    $order_status = 5;
                    break; //Платеж отклонен.
                case 'REVERSED':
                    $order_status = 5;
                    break; //Платеж отменен
                case 'REFUNDED':
                    $order_status = 5;
                    break; //Произведен возврат денег клиенту
            }

            if ($token == $original_token) {
                $change_status = $order->set('status', $order_status);
                $order->save();
                $modx->invokeEvent('OnSHKChangeStatus', array('order_id' => $order_id, 'status' => $order_status));
                die("OK");

            } else {
                die("NOTOK");
            }
        } else {
            die("NOTOK");
        }
    }
}